<?
// Copyright (C) 2006 Comvalid Inc
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version 0.9

include_once "pop3.obj";
include_once "htmloutput.obj";
include_once "constants.inc";
include_once "links_messages.inc";
include_once "devices.obj";
include_once "b6.obj";
include_once "disp.inc";
include_once "dataenv.obj";
include_once('Mail_Mime-1.2.1/mimeDecode.php');



//  $h = hash id
//  $u = username
//  $p = password
//  $i = ip (or server)
//  $j = previous state (Msg or MsgList)
//  $X = Exclude Filter on from in options
//  HTML variables :
//  $a = all selected/unselected, "":unsel, 1:selected
//  &k == 1     index page after login
//  &k == 4     view message with given uid
//  &k == 6     commands for delete
//  &k == 7     compose mess
//  &k == 8     send composed mess
//  &k == b     reply mess

ini_set("zlib.output_compression_level ", 9);
if ($_SERVER["HTTP_ACCEPT_ENCODING"]  != "") {
  //  ob_start("ob_gzhandler");
  ob_start(); // Ricordarsi di scommentare questa quando si toglie il GZ altrimenti non va il login
} else {
  ob_start();
}
if (!is_numeric($w)) { $w=""; } ;
$html    = new htmloutput($_SERVER["HTTP_USER_AGENT"],$w);
$dataenv = new dataenv();
$b6      = new b6();


if ($x != "") {
  error_reporting(0);
  $bkvs=gzuncompress($b6->decrypt($x));
  error_reporting(1);
  if ($bkvs != "") {
    $bkv = unserialize($bkvs);
    extract($bkv,EXTR_OVERWRITE);
  }
  $u=$bkv[u];
  $p=$bkv[p];
  $i=$bkv[i];
  $k=$bkv[k];
  $a=$bkv[a];
  
  if ( $_SERVER[HTTP_REFERER] ) {
    $bkinfo = D_BOOKMARK;
  } else {
    $bkinfo = "";
  }
}

if (!$k) {
   $html->display_indexpage($h);
   exit();
}

if ($h) {
  $dataenv->GetUserInfoFromH($h);
  $u=$dataenv->hArrUserInfo[user];
  $i=$dataenv->hArrUserInfo[ip_port];
  $p=$b6->decrypt($p);
} else {
  $dataenv->hArrUserInfo[user]    = $u;
  $dataenv->hArrUserInfo[ip_port] = $i;
}

if ($s == D_LOGOUT) {
  logout($h);
  $html->display_indexpage($h);
  exit();
}


if ( !is_array($m) ) { $m = $b6->decrypt($m); }
if ( isset($l)     ) { $l = $b6->decrypt($l); }

$make_auth = true;
if ( $s == D_OPTIONS       ||
     $s == D_SETVISOPT     ||
     $s == D_SETSENTOPT    ||
     $s == D_SETFILTER     ||
     ( ($s == D_DELETE_SEL || $s == D_DELETE) && $k<>6 )
   )
{
  $make_auth = false;
}

if ( $make_auth ) {
  $pop3lib = new POP3($i);
}

$dataenv->check_access($u,$p,$i,$h,$make_auth);

if (!$h) {
  $h = $dataenv->h;
}

if ( !isset($s) && $k==1 ) { $s = D_MSGLIST; }

if ( ($s == D_DELETE_SEL || $s == D_DELETE) && $k<>6 ) {
  confirm_delete($h,$p,$l,$m,$a,$k,$j,"","");
  exit();
}

if ( ( $s == D_DELML || $s == D_DELPREV || $s == D_DELNEXT) && $k==6 ) {
  delete($h,$p,$l,$m,$a,$j,$s,"");
  $pop3lib->quit();
  exit();
}

if ( $s == D_COMPOSE ) {
  compose_page($h,$p,$l,$k,$j,$a,$T,$C,$D,$S,$B,false,$rets);
  exit();
}

if ( $s == D_REPLY && $k<>"b") {
  reply($h,$p,$l,$m,$a,"",$T,$V,$C,$v,$D,$S,$B,false,"");
  $pop3lib->quit();
  exit();
}

if ( $s == D_REPLY && $k=="b") {
  apply_reply($h,$V,$v,$p,$l,$m,$a,$T,$C,$D,$S,$B,$o);
  $pop3lib->quit();
  exit();
}

if ( $s == D_FORWARD && $k<>"b") {
  forward($h,$p,$l,$m,$a,"",$T,$V,$C,$v,$D,$S,$B,false,"");
  $pop3lib->quit();
  exit();
}

if ( $s == D_FORWARD && $k=="b") {
  apply_forward($h,$V,$v,$p,$l,$m,$a,$T,$C,$D,$S,$B,$o);
  $pop3lib->quit();
  exit();
}

if ( $k == "8" ) {
  send_composed($h,$p,$l,$a,$j,$T,$C,$D,$S,$B);
  $pop3lib->quit();
  exit();
}

if ($k == "1") {
  if ( $s == D_NEXT ) {
     $l++;
     $s = D_MSGLIST;
  }
  if ( $s == D_PREV ) {
     $l--;
     $s = D_MSGLIST;
  }
}

if ( $s == D_SETBOOKMARK ) {
   option_page_bookmark($a,$p);
}

if ( $s == D_MSGLIST || $s == D_SETBOOKMARK || $s == D_REFRESH || $s == D_SEL_ALL || $s == D_DESEL_ALL || $s == D_ENTRA ) {
  if ( $s == D_SEL_ALL   ) { $a = 1; }
  if ( $s == D_DESEL_ALL ) { $a = 0; }
  msgindex_page($h,$p,$l,$a,$bkinfo);
  $pop3lib->quit();
  exit();
}

if ($k == "4") {
  if ( $s == D_NEXT ) {
     $m--;
  }
  if ( $s == D_PREV ) {
     $m++;
  }
  if ($s == D_VIEWFULL ) {
    msgview_page($h,$p,$l,$m,$a,$k,false,"",true,$N);
  } else {
    msgview_page($h,$p,$l,$m,$a,$k,true,"",true,$N);
  }
  $pop3lib->quit();
  exit();
}

if ( $k=="c" || $k=="c1") {
  if ($s == D_VIEWFULL ) {
    msgview_page($h,$p,$l,$m,$a,$k,false,"",false,$N);
  } else {
    msgview_page($h,$p,$l,$m,$a,$k,true,"",false,$N);
  }
  $pop3lib->quit();
  exit();
}

# From Confirm Delete the No Is pressed: (meaning Submit button is No && $k=6 <== Delete)
if ( $s == D_NO && $k == 6 ) {
  if ( $j ) {
    msgindex_page($h,$p,$l,$a,$bkinfo);
  } else {
    msgview_page($h,$p,$l,$m,$a,$k,true,"",true,$N);
  }
  $pop3lib->quit();
  exit();
}

if ( $s == D_OPTIONS ) {
  option_page($h,$p,$l,$a,$opmess);
  exit();
}

if ( $s == D_SETVISOPT ) {
  option_page_vis($h,$p,$l,$a,$opmess);
  exit();
}

if ( $s == D_SETVIS ) {
 apply_option_vis($h,$p,$l,$opmess,$J,$K,$y);
 exit();
}

if ( $s == D_SETSENTOPT ) {
  option_page_sent($h,$p,$l,$a,$opmess);
  exit();
}

if ( $s == D_SETSENT ) {
  apply_option_sent($h,$p,$l,$opmess,$F,$G,$R);
  exit();
}


if ( $s == D_SETFILTER ) {
  option_page_filter($h,$p,$l,$a,$opmess);
  exit();
}

if ( $s == D_SETFILT ) {
  apply_option_filter($h,$p,$l,$opmess,$A,$b,$X);
  exit();
}

?>
