<?
// Copyright (C) 2006 Comvalid Inc
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version 0.9

###############################################
#                                             #
# This include file contains string constants #
#                                             #
###############################################

// Dictionary
define("D_SERVER"                , "Server");
define("D_UNDEFINEDERROR"        , "Undefined Error");
define("D_MSGGONE"               , "Message non present anymore");
define("D_MSGMISSING"            , "Message Id Missing");
define("D_VIEW_ALL_ATTACHEMNTS"  , "...View All Attachments");



define("D_LOGINPAGE"             , "Login Page");
define("D_ACCESSDENIED"          , "Access Denied");
define("D_LOGININCORRECT"        , "Login Incorrect");
define("D_PDAMAILWAP"            , "wap4mail");
define("D_INDIRIZZO"             , "User");
define("D_PASSWORD"              , "Password");
define("D_REMOTEPW"              , "Mailbox Password");
define("D_GETMBXFAIL"            , "Remote mailbox unavailable");
define("D_IMAPFAIL"              , "IMAP protocol access failed");
define("D_FOLDERSLIST"           , "Folders List");
define("D_NOMESSAGES"            , "No messages to read in ");
define("D_CONFDELETE"            , "Confirm deletion");
define("D_CONFMOVE"              , "Move message to folder:");
define("D_CONFMOVES"             , "Move messages to folder:");
define("D_CONFMES"               , "of message with Subject:");
define("D_CONFMESS"              , "of messages with Subjects:");
define("D_MSGDELETED"            , "Message Deleted");
define("D_MSGSDELETED"           , "Messages Deleted");
define("D_MSGMOVED"              , "Message Moved");
define("D_MSGSMOVED"             , "Messages Moved");
define("D_NODEL"                 , "Deletion Impossible");
define("D_NOSUCHMSG"             , "No Such Message");
define("D_NOSUCHMSGS"            , "No Such Messages");
define("D_NOMOVE"                , "Move Impossible");
define("D_ATTACH1"               , "[Attachment: ");
define("D_ATTACH2"               , "]");
define("D_COMPOSES"              , "Compose new message");
define("D_TO"                    , "To:");
define("D_TOS"                   , "To");
define("D_CC"                    , "Cc:");
define("D_CCS"                   , "Cc");
define("D_BCC"                   , "Bcc:");
define("D_BCCS"                  , "Bcc");
define("D_SUBJECT"               , "Subj:");
define("D_COMPOSEBODY"           , "Mail Body:");
define("D_COMPOSETIT"            , "New Message");
define("D_MESSAGESENT"           , "Message Sent");
define("D_MESSAGENOTSENT"        , "Message Not Sent");
define("D_INCORRECTTO"           , "Incorrect To Address");
define("D_INCORRECTCC"           , "Incorrect Cc Address");
define("D_INCORRECTBCC"          , "Incorrect Bcc Address");
define("D_MESSAGENOTSTORED"      , "Message Sent Not Saved");
define("D_NOSEL"                 , "No Message Selected");
define("D_FULLNAME"              , "Full Name:");
define("D_EMAIL"                 , "Email Address:");
define("D_SENTF"                 , "Sent Folder:");
define("D_SENTFNE"               , "Please Select Sent Folder");
define("D_LOGINF"                , "Login Folder:");
define("D_LOGINFNE"              , "Please Select Login Folder");
define("D_MSG_PER_PAGE"          , "Msg per Page:");
define("D_MAXMSGSIZE"            , "Max Msg Size:");
define("D_DEVICE_FONT"           , "Text Size:");
define("D_ERRMSGNUM"             , "Msg per Page: numeric larger than 0");
define("D_ERRMAXSIZ"             , "Max Msg Size: numeric larger than 0");
define("D_ERRMAILAD"             , "Email Address: must contain valid address");
define("D_OPTIONSOK"             , "New Options Applied");
define("D_FORWARDTIT"            , "Forward Message");
define("D_FORWARDPRE"            , "Forward Mail Body:");
define("D_REPLYTIT"              , "Reply Message");
define("D_REPLYPRE"              , "Reply Mail Body:");
define("D_CONV1"                 , "Converted ");
define("D_CONV2"                 , "html message");
define("D_HTMLMESS"              , "HtmlMessage");
define("D_TXTMESS"               , "TextMessage");
define("D_MAILMESS"              , "MailMessage");
define("D_ATTACHEDMESS"          , "Attached Message");
define("D_ATTACHORIG"            , "Attach Original Message");
define("D_NOMIME"                , "--- This MessageBody type cannot be interpreted by TravelMail, sorry ---<br>");
define("D_VISOPTIONS"            , "Visualization Options");
define("D_SENTOPTIONS"           , "Sent Mail Options");
define("D_SENTDEFDOM"            , "Default Send Domain:");
define("D_SENTDEFDOMERR"         , "Incorrect Default Send Domain");
define("D_TMPASSOPTIONS"         , "TravelMail Password");
define("D_IMAPOPTIONS"           , "IMAP Server");
define("D_FOLDOPTIONS"           , "Folders to Exclude");
define("D_FILTOPTIONS"           , "INBOX Message Filter Criteria");
define("D_FILTNONE"              , "View all messages");
define("D_FILTFROM"              , "View only if From is matching:");
define("D_NEWFILTER"             , "New match:");
define("D_OLDPASS"               , "Old Password:");
define("D_NEWPASS"               , "New Password:");
define("D_OLDIPASS"              , "Old IMAP Password:");
define("D_NEWIPASS"              , "New IMAP Password:");
define("D_PASSWORDERR"           , "Incorrect Old Password");
define("D_PASSWORDDIFF"          , "New Password Not Confirmed");
define("D_IPASSWORDDIFF"         , "New IMAP Password Not Confirmed");
define("D_IPASSWORERR"           , "Incorrect IMAP Password");
define("D_IPASSCK"               , "Mailbox access failed, check IMAP Password");
define("D_BOOKMARK"              , "Bookmark this page for direct access");
define("D_DEVSPEC"               , "Device Specific:");
define("D_ADDRDISP"              , "Address Display:");
define("D_FULL"                  , "Full");
define("D_SHORT"                 , "Short");


// Items for submit buttons, do not use any special char as spaces,<>," inside them
define("D_ENTRA"                 , "Login");
define("D_FOLDERS"               , "Folders");
define("D_OPTIONS"               , "Options");
define("D_COMPOSE"               , "NewMsg");
define("D_SEL_ALL"               , "SetSel");
define("D_DESEL_ALL"             , "UnSetSel");
define("D_DELETE_SEL"            , "DelSel");
define("D_MOVE_SEL"              , "MoveSel");
define("D_PREV"                  , "");
define("D_NEXT"                  , "");
define("D_REPLY"                 , "Reply");
define("D_FORWARD"               , "Forward");
define("D_DELETE"                , "Del");
define("D_DELML"                 , "Del(MsgList)");
define("D_DELFL"                 , "Del(Folders)");
define("D_DELPREV"               , "Del()");
define("D_DELNEXT"               , "Del()");
define("D_MOVE"                  , "Move");
define("D_MSGLIST"               , "MsgList");
define("D_NO"                    , "No");
define("D_REFRESH"               , "Refresh");
define("D_SEND"                  , "Send");
define("D_VIEWFULL"              , "ViewAll");
define("D_ADDRHELP"              , "Latest@");
define("D_NOADDRHELP"            , "NoLatest@");
define("D_SETVIS"                , "SetVisualization");
define("D_SETSENT"               , "SetSent");
define("D_SETPASS"               , "SetPass");
define("D_SETIMAP"               , "SetImap");
define("D_SETEXCL"               , "SetExclude");
define("D_SETFILT"               , "SetFilter");
define("D_SETVISOPT"             , "VisualizationOptions");
define("D_SETSENTOPT"            , "SentMailOptions");
define("D_SETPASSOPT"            , "ChangePassword");
define("D_SETIMAPOPT"            , "ImapPassword");
define("D_SETEXCLOPT"            , "ExcludeFolders");
define("D_SETBOOKMARK"           , "PageToBookmark");
define("D_REFRESH"               , "Refresh");
define("D_SETFILTER"             , "FilterMessages");
define("D_LOGOUT"                , "Logout");
define("D_HELP"                  , "Help");



